﻿using System.Security.Cryptography.X509Certificates;
using SoapEndpoint.Service.Proxy.Models.Systeem;

namespace SoapEndpoint.Tester.Infrastructure;

public class CertificateItem
{
    public CertificateItem(string name)
    {
        Name = name;
    }

    public CertificateItem(X509Certificate2 cert)
    {
        Certificate = cert;
        Name = cert.GetNameInfo(X509NameType.SimpleName, false);
        Type = CertificateHelper.GetOrganisationType(this);
    }

    public X509Certificate2 Certificate { get; }
    public string Name { get; }
    public OrganisatieType? Type { get; }
}