﻿using SoapEndpoint.Service.Flows.Waarborgfonds.v1.LogbookService;
using SoapEndpoint.Service.Proxy.Models.Flows;
using SoapEndpoint.Service.Proxy.Models.Systeem;

namespace SoapEndpoint.Tester.Scenario.Implementations.Waarborgfonds;

public abstract class WaarborgfondsScenarioBase : ScenarioBase
{
    protected BerichtType[] SeReplyMessageTypes =
    {
        BerichtType.SE_BorgstellingAfgegeven,
        BerichtType.SE_BorgstellingBeeindigd,
        BerichtType.SE_BorgstellingUitbetaald,
        BerichtType.SE_UitbetaalverzoekAfgewezen,
        BerichtType.SE_BorgstellingAanvraagAfgewezen,
        BerichtType.SE_BorgstellingAanvraagBeeindigd,
        BerichtType.SE_ProFormaAanvraagAfgewezen,
        BerichtType.SE_ProFormaBorgstellingAfgegeven
    };

    public override AdresboekOrganisatieModel SeOrganization =>
        Manager.Organizations.SingleOrDefault(p => p.Referentienummer.ToString()
            .Equals(Program.Configuration["WaarborgfondsOrganizationReference"],
                StringComparison.CurrentCultureIgnoreCase));

    public override FlowType FlowType => FlowType.Waarborgfonds;

    public override Version FlowVersion => new(1, 0);
}