﻿using SoapEndpoint.Service.Proxy.Models.Flows;

namespace SoapEndpoint.Tester.Scenario;

public static class Scenarios
{
    public static Dictionary<FlowType, List<ScenarioBase>> Items { get; } = typeof(Scenarios).Assembly
        .GetExportedTypes()
        .Where(t => typeof(ScenarioBase).IsAssignableFrom(t) && !t.IsAbstract && !t.IsGenericType)
        .Select(Activator.CreateInstance)
        .Cast<ScenarioBase>()
        .Where(s => s.DisplayInList)
        .GroupBy(s => s.FlowType)
        .ToDictionary(g => g.Key, g => g.ToList());
}