﻿using AutoMapper;
using SoapEndpoint.Service.Proxy.Models.Systeem;
using SoapEndpoint.Service.Systeem.v1.AddressService;

namespace SoapEndpoint.Service.Proxy.ServiceProxies.Systeem.v1;

public class AddressBookProxy : IAddressBookProxy
{
    private readonly IMapper _mapper;
    private readonly IAddressService _service;

    public AddressBookProxy(IMapper mapper, IAddressService service)
    {
        _mapper = mapper;
        _service = service;
    }

    public async Task<AdresboekOrganisatieModel?> GetOrganizationAsync()
    {
        var response = await _service.GetOrganizationAsync();
        return _mapper.Map<AdresboekOrganisatieModel>(response);
    }

    public async Task<AdresboekOrganisatieModel[]> GetOrganizationsAsync(AdresboekZoekBerichtModel request)
    {
        var message = _mapper.Map<AdresboekZoekbericht>(request);
        var response = await _service.GetOrganizationsAsync(message);
        return _mapper.Map<AdresboekOrganisatieModel[]>(response);
    }

    public async Task UpdateOrganizationAsync(UpdateOrganisatieBerichtModel request)
    {
        var message = _mapper.Map<UpdateOrganisatieBericht>(request);
        await _service.UpdateOrganizationAsync(message);
    }
}